/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokConnectorForm{}

// TikTokConnectorForm struct for TikTokConnectorForm
type TikTokConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuthId
	OAuthId string `json:"oAuthId"`
	// Label
	Label string `json:"label"`
	// TikTok advertiser ID
	AdvertiserId string `json:"advertiserId"`
	// Data range expression. Required for automation
	DateRange string `json:"dateRange"`
	// Metrics to be included in the result
	Metric []string `json:"metric"`
	// Data labels to be included in the result
	DataLabel []string `json:"dataLabel"`
	// ID dimension to be included in the result
	IdDimension string `json:"idDimension"`
	// Audience dimension to be included in the result
	AudienceDimension string `json:"audienceDimension"`
	// The report type
	ReportType string `json:"reportType"`
	// The data level
	DataLevel string `json:"dataLevel"`
}

// NewTikTokConnectorForm instantiates a new TikTokConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, advertiserId string, dateRange string, metric []string, dataLabel []string, idDimension string, audienceDimension string, reportType string, dataLevel string) *TikTokConnectorForm {
	this := TikTokConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.AdvertiserId = advertiserId
	this.DateRange = dateRange
	this.Metric = metric
	this.DataLabel = dataLabel
	this.IdDimension = idDimension
	this.AudienceDimension = audienceDimension
	this.ReportType = reportType
	this.DataLevel = dataLevel
	return &this
}

// NewTikTokConnectorFormWithDefaults instantiates a new TikTokConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokConnectorFormWithDefaults() *TikTokConnectorForm {
	this := TikTokConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *TikTokConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *TikTokConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *TikTokConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *TikTokConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *TikTokConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *TikTokConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *TikTokConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *TikTokConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *TikTokConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *TikTokConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *TikTokConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *TikTokConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *TikTokConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetAdvertiserId returns the AdvertiserId field value
func (o *TikTokConnectorForm) GetAdvertiserId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AdvertiserId
}

// GetAdvertiserIdOk returns a tuple with the AdvertiserId field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetAdvertiserIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AdvertiserId, true
}

// SetAdvertiserId sets field value
func (o *TikTokConnectorForm) SetAdvertiserId(v string) {
	o.AdvertiserId = v
}

// GetDateRange returns the DateRange field value
func (o *TikTokConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *TikTokConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

// GetMetric returns the Metric field value
func (o *TikTokConnectorForm) GetMetric() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metric, true
}

// SetMetric sets field value
func (o *TikTokConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetDataLabel returns the DataLabel field value
func (o *TikTokConnectorForm) GetDataLabel() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetDataLabelOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DataLabel, true
}

// SetDataLabel sets field value
func (o *TikTokConnectorForm) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetIdDimension returns the IdDimension field value
func (o *TikTokConnectorForm) GetIdDimension() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.IdDimension
}

// GetIdDimensionOk returns a tuple with the IdDimension field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetIdDimensionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.IdDimension, true
}

// SetIdDimension sets field value
func (o *TikTokConnectorForm) SetIdDimension(v string) {
	o.IdDimension = v
}

// GetAudienceDimension returns the AudienceDimension field value
func (o *TikTokConnectorForm) GetAudienceDimension() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AudienceDimension
}

// GetAudienceDimensionOk returns a tuple with the AudienceDimension field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetAudienceDimensionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AudienceDimension, true
}

// SetAudienceDimension sets field value
func (o *TikTokConnectorForm) SetAudienceDimension(v string) {
	o.AudienceDimension = v
}

// GetReportType returns the ReportType field value
func (o *TikTokConnectorForm) GetReportType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetReportTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReportType, true
}

// SetReportType sets field value
func (o *TikTokConnectorForm) SetReportType(v string) {
	o.ReportType = v
}

// GetDataLevel returns the DataLevel field value
func (o *TikTokConnectorForm) GetDataLevel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DataLevel
}

// GetDataLevelOk returns a tuple with the DataLevel field value
// and a boolean to check if the value has been set.
func (o *TikTokConnectorForm) GetDataLevelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DataLevel, true
}

// SetDataLevel sets field value
func (o *TikTokConnectorForm) SetDataLevel(v string) {
	o.DataLevel = v
}

func (o TikTokConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["advertiserId"] = o.AdvertiserId
	toSerialize["dateRange"] = o.DateRange
	toSerialize["metric"] = o.Metric
	toSerialize["dataLabel"] = o.DataLabel
	toSerialize["idDimension"] = o.IdDimension
	toSerialize["audienceDimension"] = o.AudienceDimension
	toSerialize["reportType"] = o.ReportType
	toSerialize["dataLevel"] = o.DataLevel
	return toSerialize, nil
}

type NullableTikTokConnectorForm struct {
	value *TikTokConnectorForm
	isSet bool
}

func (v NullableTikTokConnectorForm) Get() *TikTokConnectorForm {
	return v.value
}

func (v *NullableTikTokConnectorForm) Set(val *TikTokConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokConnectorForm(val *TikTokConnectorForm) *NullableTikTokConnectorForm {
	return &NullableTikTokConnectorForm{value: val, isSet: true}
}

func (v NullableTikTokConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
